angular.module('your_app_name.controllers', [])

.controller('AuthCtrl', function($scope, $ionicConfig) {

})

// APP
.controller('AppCtrl', function($scope, $ionicConfig) {

})

// Home
.controller('HomeCtrl', function($scope, $ionicConfig) {

})

//LOGIN
.controller('LoginCtrl', function($scope, $state, $templateCache, $q, $rootScope) {
	$scope.doLogIn = function(){
		$state.go('app.feeds-categories');
	};

	$scope.user = {};

	$scope.user.email = "john@doe.com";
	$scope.user.pin = "12345";

	// We need this for the form validation
	$scope.selected_tab = "";

	$scope.$on('my-tabs-changed', function (event, data) {
		$scope.selected_tab = data.title;
	});

})

/*
.controller('SignupCtrl', function($scope, $state) {
	$scope.user = {};

	$scope.user.email = "john@doe.com";

	$scope.doSignUp = function(){
		$state.go('app.feeds-categories');
	};
})

.controller('ForgotPasswordCtrl', function($scope, $state) {
	$scope.recoverPassword = function(){
		$state.go('app.feeds-categories');
	};

	$scope.user = {};
})

.controller('RateApp', function($scope) {
	$scope.rateApp = function(){
		if(ionic.Platform.isIOS()){
			//you need to set your own ios app id
			AppRate.preferences.storeAppURL.ios = '1234555553>';
			AppRate.promptForRating(true);
		}else if(ionic.Platform.isAndroid()){
			//you need to set your own android app id
			AppRate.preferences.storeAppURL.android = 'market://details?id=ionFB';
			AppRate.promptForRating(true);
		}
	};
})

.controller('SendMailCtrl', function($scope) {
	$scope.sendMail = function(){
		cordova.plugins.email.isAvailable(
			function (isAvailable) {
				// alert('Service is not available') unless isAvailable;
				cordova.plugins.email.open({
					to:      'envato@startapplabs.com',
					cc:      'hello@startapplabs.com',
					// bcc:     ['john@doe.com', 'jane@doe.com'],
					subject: 'Greetings',
					body:    'How are you? Nice greetings from IonFullApp'
				});
			}
		);
	};
})

.controller('MapsCtrl', function($scope, $ionicLoading) {

	$scope.info_position = {
		lat: 43.07493,
		lng: -89.381388
	};

	$scope.center_position = {
		lat: 43.07493,
		lng: -89.381388
	};

	$scope.my_location = "";

	$scope.$on('mapInitialized', function(event, map) {
		$scope.map = map;
	});

	$scope.centerOnMe= function(){

		$scope.positions = [];

		$ionicLoading.show({
			template: 'Loading...'
		});

		// with this function you can get the user’s current position
		// we use this plugin: https://github.com/apache/cordova-plugin-geolocation/
		navigator.geolocation.getCurrentPosition(function(position) {
			var pos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
			$scope.current_position = {lat: pos.G,lng: pos.K};
			$scope.my_location = pos.G+", "+pos.K;
			$scope.map.setCenter(pos);
			$ionicLoading.hide();
		});
	};
})

.controller('AdsCtrl', function($scope, $ionicActionSheet, AdMob, iAd) {

	$scope.manageAdMob = function() {

		// Show the action sheet
		var hideSheet = $ionicActionSheet.show({
			//Here you can add some more buttons
			buttons: [
				{ text: 'Show Banner' },
				{ text: 'Show Interstitial' }
			],
			destructiveText: 'Remove Ads',
			titleText: 'Choose the ad to show',
			cancelText: 'Cancel',
			cancel: function() {
				// add cancel code..
			},
			destructiveButtonClicked: function() {
				console.log("removing ads");
				AdMob.removeAds();
				return true;
			},
			buttonClicked: function(index, button) {
				if(button.text == 'Show Banner')
				{
					console.log("show banner");
					AdMob.showBanner();
				}

				if(button.text == 'Show Interstitial')
				{
					console.log("show interstitial");
					AdMob.showInterstitial();
				}

				return true;
			}
		});
	};

	$scope.manageiAd = function() {

		// Show the action sheet
		var hideSheet = $ionicActionSheet.show({
			//Here you can add some more buttons
			buttons: [
			{ text: 'Show iAd Banner' },
			{ text: 'Show iAd Interstitial' }
			],
			destructiveText: 'Remove Ads',
			titleText: 'Choose the ad to show - Interstitial only works in iPad',
			cancelText: 'Cancel',
			cancel: function() {
				// add cancel code..
			},
			destructiveButtonClicked: function() {
				console.log("removing ads");
				iAd.removeAds();
				return true;
			},
			buttonClicked: function(index, button) {
				if(button.text == 'Show iAd Banner')
				{
					console.log("show iAd banner");
					iAd.showBanner();
				}
				if(button.text == 'Show iAd Interstitial')
				{
					console.log("show iAd interstitial");
					iAd.showInterstitial();
				}
				return true;
			}
		});
	};
})
*/

// FEED
//brings all feed categories
/*.controller('FeedsCategoriesCtrl', function($scope, $http) {
	$scope.feeds_categories = [];
	/!*$http.get('feeds-categories.json').success(function(response) {
		$scope.feeds_categories = response;
	});*!/
})*/
.controller('FeedsCategoriesCtrl', ['$scope', '$stateParams', 'Categories',
	function ($scope, $stateParams, Categories) {

		$scope.feeds_categories = [];
		$scope.vert5 = true;
		if(ionic.Platform.platform() == 'android' && parseFloat(ionic.Platform.version()) < 5)
		{
			$scope.vert5 = false;
		}
		cats = Categories.all().success(function (data) {
			if(data.success){
				$scope.feeds_categories = data.cats;
			}else{
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}

		});

	}])

//bring specific category providers
/*
.controller('CategoryFeedsCtrl', function($scope, $http, $stateParams) {
	$scope.category_sources = [];

	$scope.categoryId = $stateParams.categoryId;
	console.log($scope.categoryId);

	$http.get('feeds-categories.json').success(function(response) {
		var category = _.find(response, {id: $scope.categoryId});
		$scope.categoryTitle = category.title;
		$scope.category_sources = category.feed_sources;
	});
})
*/

.controller('CategoryFeedsCtrl', ['$scope', '$stateParams', '$location', 'Categories', '$ionicPopup', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
function ($scope, $stateParams, $location, Categories, $ionicPopup) {

	$scope.category_sources = [];
	$scope.products = [];
	$scope.categoryTitle = '';
	$scope.image_path = '';
	$scope.prd = false;
	$scope.vert5 = true;
	if(ionic.Platform.platform() == 'android' && parseFloat(ionic.Platform.version()) < 5)
	{
		$scope.vert5 = false;
	}
	$scope.categoryId = $stateParams.categoryId;
	Categories.get($scope.categoryId).success(function (data) {
		if(data.success){
			$scope.prd = data.products;
			if(data.products){
				$scope.image_path = 'http://dahua.ir/uploads/products_files/file';
			}else{
				$scope.image_path = 'http://dahua.ir/uploads/categories/image';
			}
			$scope.categoryTitle = $stateParams.categoryName;
			$scope.category_sources = data.cats;
			console.log(data.cats);
		}else{
			$ionicPopup.alert({
				title: 'Sorry!',
				template: data.message
			});
		}

	});

}])

.controller('productCtrl', ['$scope', '$stateParams', 'Products', '$ionicPopup',
function ($scope, $stateParams, Products, $ionicPopup) {
	$scope.product = [];
	$scope.image_path = 'http://dahua.ir/uploads/products_files/file';
	product = Products.get($stateParams.prdId).success(function (data) {
		if(data.success){
			$scope.product = data.product;
			console.log($scope.product);
		}else{
			$ionicPopup.alert({
				title: 'Sorry!',
				template: data.message
			});
		}
	});
}])

.controller('InquiryCtrl', ['$scope', '$stateParams', 'Inquiry', '$ionicPopup', '$cordovaBarcodeScanner',
function ($scope, $stateParams, Inquiry, $ionicPopup, $cordovaBarcodeScanner) {

	$scope.guaranty = [];
	$scope.submit = function(){
		guaranty = Inquiry.get($scope.guaranty.serial).success(function (data) {
			if(data.success){
				$scope.guaranty = data.guaranty;
				//console.log($scope.guaranty);
				$ionicPopup.alert({
					title: 'Thank You!',
					template: 'گارانتی شما موجود است'
				});
			}else{
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}

		});
	};
	
	$scope.scanBarcode = function() {
	$cordovaBarcodeScanner.scan().then(function(imageData) {
		$scope.barcode = imageData;
		guaranty = Inquiry.get(imageData.text).success(function (data) {
			if(data.success){
				$scope.guaranty = data.guaranty;
				//console.log($scope.guaranty);
				$ionicPopup.alert({
					title: 'Thank You!',
					template: 'گارانتی شما موجود است'
				});
			}else{
				$scope.guaranty.serial = imageData.text;
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}
		});
			//alert(imageData.text);
			//console.log("Barcode Format -> " + imageData.format);
			//console.log("Cancelled -> " + imageData.cancelled);
		}, function(error) {
			console.log("An error happened -> " + error);
		});
	};

}])

.controller('SearchCtrl', ['$scope', '$stateParams', 'Search', '$ionicPopup',
	function ($scope, $stateParams, Search, $ionicPopup) {
		$scope.products = [];
		$scope.search = [];
		$scope.image_path = 'http://dahua.ir/uploads/products_files/file';
		//$scope.search.platform = ionic.Platform.platform();
		//$scope.search.version = parseFloat(ionic.Platform.version());
		$scope.vert5 = true;
		if(ionic.Platform.platform() == 'android' && parseFloat(ionic.Platform.version()) < 5)
		{
			$scope.vert5 = false;
		}
		$scope.submit = function(){
			Search.get($scope.search.name).success(function (data) {
			if(data.success){
				$scope.products = data.products;
				console.log($scope.products);
			}else{
				$scope.products = [];
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}

			});
		};
	}])

/*.controller('NewsCtrl', ['$scope', '$stateParams', 'News', '$ionicPopup',
function ($scope, $stateParams, News, $ionicPopup) {

	$scope.feeds_categories = [];
	cats = News.all().success(function (data) {
		if(data.success){
			$scope.news = data.news;
		}else{
			$ionicPopup.alert({
				title: 'Sorry!',
				template: data.message
			});
		}
	});
}])*/

.controller('BarcodeCtrl', ['$scope', '$stateParams', '$cordovaBarcodeScanner',
function ($scope, $stateParams, $cordovaBarcodeScanner) {
	$scope.scanBarcode = function() {
		$cordovaBarcodeScanner.scan().then(function(imageData) {
			$scope.barcode = imageData;
			//alert(imageData.text);
			//console.log("Barcode Format -> " + imageData.format);
			//console.log("Cancelled -> " + imageData.cancelled);
		}, function(error) {
			console.log("An error happened -> " + error);
		});
	};
}])

.controller('PartnerCategoriesCtrl', ['$scope', '$stateParams', 'PartnerCategories', '$ionicPopup',
			function ($scope, $stateParams, PartnerCategories, $ionicPopup) {

				$scope.feeds_categories = [];
				PartnerCategories.all().success(function (data) {
					console.log(data);
					if(data.success){
						$scope.partner_categories = data.data;
					}else{
						$ionicPopup.alert({
							title: 'Sorry!',
							template: data.message
						});
					}

				});

			}])

.controller('CategoryPartnerCtrl', ['$scope', '$stateParams', '$location', 'PartnerCategories', '$ionicPopup',
	function ($scope, $stateParams, $location, PartnerCategories, $ionicPopup) {

		$scope.category_sources = [];
		$scope.categoryTitle = '';
		$scope.image_path = '';
		$scope.categoryId = $stateParams.categoryId;
		PartnerCategories.get($scope.categoryId).success(function (data) {
			console.log(data.data);
			if(data.success){
				$scope.image_path = 'http://dahua.ir/uploads/partner/image';
				$scope.categoryTitle = $stateParams.categoryName;
				$scope.category_sources = data.data;
			}else{
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}

		});

	}])

.controller('PartnerCtrl', ['$scope', '$stateParams', 'Partner', '$ionicPopup',
	function ($scope, $stateParams, Partner, $ionicPopup) {
		$scope.partner = [];
		$scope.image_path = 'http://dahua.ir/uploads/partner/image';
		Partner.get($stateParams.partnerId).success(function (data) {
			if(data.success){
				$scope.partner = data.data;
				console.log($scope.partner);
			}else{
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}
		});
	}])

.controller('ContactUsCtrl', ['$scope', '$stateParams', 'AboutUs', '$ionicPopup',
	function ($scope, $stateParams, AboutUs, $ionicPopup) {
		$scope.page = [];
		AboutUs.get().success(function (data) {
			if(data.success){
				$scope.page = data.data;
			}else{
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}
		});
	}])
	
.controller('AboutUsCtrl', ['$scope', '$stateParams', 'AboutUs', '$ionicPopup',
function ($scope, $stateParams, AboutUs, $ionicPopup) {
	$scope.page = [];
	AboutUs.get().success(function (data) {
		if(data.success){
			$scope.page = data.data;
		}else{
			$ionicPopup.alert({
				title: 'Sorry!',
				template: data.message
			});
		}
	});
}])

.controller('ServiceCategoriesCtrl', ['$scope', '$stateParams', 'ServiceCategories', '$ionicPopup',
	function ($scope, $stateParams, ServiceCategories, $ionicPopup) {

		$scope.feeds_categories = [];
		ServiceCategories.all().success(function (data) {
			console.log(data);
			if(data.success){
				$scope.service_categories = data.data;
			}else{
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}

		});

	}])

.controller('CategoryServiceCtrl', ['$scope', '$stateParams', '$location', 'ServiceCategories', '$ionicPopup',
	function ($scope, $stateParams, $location, ServiceCategories, $ionicPopup) {

		$scope.category_sources = [];
		$scope.categoryTitle = '';
		$scope.image_path = '';
		$scope.categoryId = $stateParams.categoryId;
		ServiceCategories.get($scope.categoryId).success(function (data) {
			console.log(data.data);
			if(data.success){
				$scope.image_path = 'http://dahua.ir/uploads/service/image';
				$scope.categoryTitle = $stateParams.categoryName;
				$scope.category_sources = data.data;
			}else{
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}

		});

	}])

.controller('ServiceCtrl', ['$scope', '$stateParams', 'Service', '$ionicPopup',
	function ($scope, $stateParams, Service, $ionicPopup) {
		$scope.service = [];
		$scope.image_path = 'http://dahua.ir/uploads/service/image';
		Service.get($stateParams.serviceId).success(function (data) {
			if(data.success){
				$scope.service = data.data;
				console.log($scope.service);
			}else{
				$ionicPopup.alert({
					title: 'Sorry!',
					template: data.message
				});
			}
		});
	}])

/*
    //this method brings posts for a source provider
    .controller('FeedEntriesCtrl', function($scope, $stateParams, $http, FeedList, $q, $ionicLoading, BookMarkService) {
        $scope.feed = [];

        var categoryId = $stateParams.categoryId,
                sourceId = $stateParams.sourceId;

        $scope.doRefresh = function() {

            $http.get('feeds-categories.json').success(function(response) {

                $ionicLoading.show({
                    template: 'Loading entries...'
                });

                var category = _.find(response, {id: categoryId }),
                        source = _.find(category.feed_sources, {id: sourceId });

                $scope.sourceTitle = source.title;

                FeedList.get(source.url)
                .then(function (result) {
                    $scope.feed = result.feed;
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.refreshComplete');
                }, function (reason) {
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.refreshComplete');
                });
            });
        };

        $scope.doRefresh();

        $scope.bookmarkPost = function(post){
            $ionicLoading.show({ template: 'Post Saved!', noBackdrop: true, duration: 1000 });
            BookMarkService.bookmarkFeedPost(post);
        };
    })
    */

/*
// SETTINGS
.controller('SettingsCtrl', function($scope, $ionicActionSheet, $state) {
	$scope.airplaneMode = true;
	$scope.wifi = false;
	$scope.bluetooth = true;
	$scope.personalHotspot = true;

	$scope.checkOpt1 = true;
	$scope.checkOpt2 = true;
	$scope.checkOpt3 = false;

	$scope.radioChoice = 'B';

	// Triggered on a the logOut button click
	$scope.showLogOutMenu = function() {

		// Show the action sheet
		var hideSheet = $ionicActionSheet.show({
			//Here you can add some more buttons
			// buttons: [
			// { text: '<b>Share</b> This' },
			// { text: 'Move' }
			// ],
			destructiveText: 'Logout',
			titleText: 'Are you sure you want to logout? This app is awsome so I recommend you to stay.',
			cancelText: 'Cancel',
			cancel: function() {
				// add cancel code..
			},
			buttonClicked: function(index) {
				//Called when one of the non-destructive buttons is clicked,
				//with the index of the button that was clicked and the button object.
				//Return true to close the action sheet, or false to keep it opened.
				return true;
			},
			destructiveButtonClicked: function(){
				//Called when the destructive button is clicked.
				//Return true to close the action sheet, or false to keep it opened.
				$state.go('auth.walkthrough');
			}
		});

	};
})

// TINDER CARDS
.controller('TinderCardsCtrl', function($scope, $http) {

	$scope.cards = [];


	$scope.addCard = function(img, name) {
		var newCard = {image: img, name: name};
		newCard.id = Math.random();
		$scope.cards.unshift(angular.extend({}, newCard));
	};

	$scope.addCards = function(count) {
		$http.get('http://api.randomuser.me/?results=' + count).then(function(value) {
			angular.forEach(value.data.results, function (v) {
				$scope.addCard(v.user.picture.large, v.user.name.first + " " + v.user.name.last);
			});
		});
	};

	$scope.addFirstCards = function() {
		$scope.addCard("https://dl.dropboxusercontent.com/u/30675090/envato/tinder-cards/left.png","Nope");
		$scope.addCard("https://dl.dropboxusercontent.com/u/30675090/envato/tinder-cards/right.png", "Yes");
	};

	$scope.addFirstCards();
	$scope.addCards(5);

	$scope.cardDestroyed = function(index) {
		$scope.cards.splice(index, 1);
		$scope.addCards(1);
	};

	$scope.transitionOut = function(card) {
		console.log('card transition out');
	};

	$scope.transitionRight = function(card) {
		console.log('card removed to the right');
		console.log(card);
	};

	$scope.transitionLeft = function(card) {
		console.log('card removed to the left');
		console.log(card);
	};
})
*/

// BOOKMARKS
/*
.controller('BookMarksCtrl', function($scope, $rootScope, BookMarkService, $state) {

	$scope.bookmarks = BookMarkService.getBookmarks();

	// When a new post is bookmarked, we should update bookmarks list
	$rootScope.$on("new-bookmark", function(event){
		$scope.bookmarks = BookMarkService.getBookmarks();
	});

	$scope.goToFeedPost = function(link){
		window.open(link, '_blank', 'location=yes');
	};
	$scope.goToWordpressPost = function(postId){
		$state.go('app.post', {postId: postId});
	};
})
*/

// News
.controller('NewsCtrl', function($scope, $http, $ionicLoading, PostService, BookMarkService) {
			$scope.posts = [];
			$scope.page = 1;
			$scope.totalPages = 1;

			$scope.doRefresh = function() {
				$ionicLoading.show({
					template: 'Loading posts...'
				});

				//Always bring me the latest posts => page=1
				PostService.getRecentPosts(1)
						.then(function(data){
							//$scope.totalPages = data.pages;
							$scope.posts = PostService.shortenPosts(data.news);

							$ionicLoading.hide();
							$scope.$broadcast('scroll.refreshComplete');
						});
			};

			$scope.loadMoreData = function(){
				$scope.page += 1;

				PostService.getRecentPosts($scope.page)
						.then(function(data){
							//We will update this value in every request because new posts can be created
							$scope.totalPages = data.pages;
							var new_posts = PostService.shortenPosts(data.posts);
							$scope.posts = $scope.posts.concat(new_posts);

							$scope.$broadcast('scroll.infiniteScrollComplete');
						});
			};

			$scope.moreDataCanBeLoaded = function(){
				return $scope.totalPages > $scope.page;
			};

			$scope.bookmarkPost = function(post){
				$ionicLoading.show({ template: 'Post Saved!', noBackdrop: true, duration: 1000 });
				//BookMarkService.bookmarkWordpressPost(post);
			};

			$scope.doRefresh();
		})

// News More
.controller('NewsPostCtrl', function($scope, post_data, $ionicLoading) {

	$scope.post = post_data.news;
	console.log($scope.post);
	$ionicLoading.hide();

/*	$scope.sharePost = function(){
		link = 'dahua.ir/morenews/' + $scope.post.id;
		console.log(link);
		window.plugins.socialsharing.share('Check this post here: ', null, null, link);
	};*/
})

/*
.controller('ImagePickerCtrl', function($scope, $rootScope, $cordovaCamera) {

	$scope.images = [];

	$scope.selImages = function() {

		window.imagePicker.getPictures(
			function(results) {
				for (var i = 0; i < results.length; i++) {
					console.log('Image URI: ' + results[i]);
					$scope.images.push(results[i]);
				}
				if(!$scope.$$phase) {
					$scope.$apply();
				}
			}, function (error) {
				console.log('Error: ' + error);
			}
		);
	};

	$scope.removeImage = function(image) {
		$scope.images = _.without($scope.images, image);
	};

	$scope.shareImage = function(image) {
		window.plugins.socialsharing.share(null, null, image);
	};

	$scope.shareAll = function() {
		window.plugins.socialsharing.share(null, null, $scope.images);
	};
})
*/


;
